package com.ye.back.controller;

import com.alibaba.fastjson.JSON;
import com.ye.back.entity.School;
import com.ye.back.response.Result;
import com.ye.back.service.SchoolService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @PackageName:com.ye.back.controller
 * @ClassName:TermController
 * @Description:
 */
@RestController
@RequestMapping("/school")
public class SchoolController {

    @Autowired
    private SchoolService schoolService;

    @ApiOperation("获取列表")
    @GetMapping("/list")
    public String list() {
        List<School> list = schoolService.list();
        if (list == null) {
            return JSON.toJSONString(new Result().setCode(500).setMessage("获取错误"));
        } else {
            return JSON.toJSONString(new Result().setCode(200).setMessage("获取成功").setData(list));
        }
    }

    @ApiOperation("新增")
    @PostMapping("/create")
    public String create(@RequestBody School school) {
        boolean result = schoolService.save(school);
        if (result){
            return JSON.toJSONString(new Result().setCode(200).setMessage("成功"));
        }else {
            return JSON.toJSONString(new Result().setCode(500).setMessage("失败"));
        }
    }

    @ApiOperation("修改")
    @PostMapping("/update")
    public String update(@RequestBody School school) {
        boolean result = schoolService.updateById(school);
        if (result){
            return JSON.toJSONString(new Result().setCode(200).setMessage("成功"));
        }else {
            return JSON.toJSONString(new Result().setCode(500).setMessage("失败"));
        }
    }

    @ApiOperation("删除")
    @DeleteMapping("/delete")
    public String delete(Integer id) {
        boolean result = schoolService.removeById(id);
        if (result){
            return JSON.toJSONString(new Result().setCode(200).setMessage("成功"));
        }else {
            return JSON.toJSONString(new Result().setCode(500).setMessage("失败"));
        }
    }

}
