package com.ye.back.dto;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.alibaba.fastjson.JSON;
import com.ye.back.entity.User;
import com.ye.back.service.UserService;
import com.ye.back.util.StringUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;

@Slf4j
public class UserListener  extends AnalysisEventListener<User> {

    private UserService userService;

    private List<User> list = new ArrayList<>();

    public UserListener(UserService userService) {
        this.userService = userService;
    }

    @Override
    public void invoke(User user, AnalysisContext analysisContext) {
        if (null == user) return;
        log.info("解析到一条数据:{}", JSON.toJSONString(user));
        user.setSalt("wcwad12");
        user.setPassword(StringUtil.md5(user.getPassword()+"wcwad12"));
        list.add(user);

        if (list.size()>5){
            userService.saveBatch(list);
            list = new ArrayList<>();
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        log.info("所有数据解析完成！");
        userService.saveBatch(list);
        log.info("存储数据库成功！");
    }
}
