package com.ye.back.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.stereotype.Component;

import java.io.Serializable;

/**
 * <p>
 * 
 * </p>
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Component
@AllArgsConstructor
@NoArgsConstructor
@ApiModel("用户实体")
@ColumnWidth(20)
public class User implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "user_id", type = IdType.AUTO)
    @ApiModelProperty("用户id")
    private Integer userId;

    @ApiModelProperty("用户名")
    @ExcelProperty(value = "用户名", index = 0)
    private String username;

    @ApiModelProperty("密码")
    @ExcelProperty(value = "密码", index = 1)
    private String password;

    @ApiModelProperty("加密的盐")
    private String salt;

    @ApiModelProperty("姓名")
    @ExcelProperty(value = "姓名", index = 2)
    private String nickname;

    @ApiModelProperty("学院id")
    @ExcelProperty(value = "学院id", index = 3)
    private int schoolId;

    @ApiModelProperty("性别")
    @ExcelProperty(value = "性别", index = 4)
    private String sex;

    @ApiModelProperty("电话号码")
    @ExcelProperty(value = "电话号码", index = 5)
    private String tel;

    @ApiModelProperty("班级")
    @ExcelProperty(value = "班级", index = 6)
    private String studentClass;

}
